#setenv CFLAGS "-g -Wall -Wno-parentheses -Wno-switch -Wno-format -Wno-unused -Werror"; python setup.py install --prefix=/home/blackett

from distutils.core import setup, Extension

setup(name="Cmiss",
      version="1.0",
      description="Cmiss python interface",
      author="Shane Blackett",
      author_email="s.blackett@auckland.ac.nz",
      url="http://www.cmiss.org",
      packages=['Cmiss', 'Cmiss.Region', 'Cmiss.Value', 'Cmiss.Value.C', 'Cmiss.Variable', 'Cmiss.Variable.C'],
      ext_modules=[
        Extension("Cmiss.Cmgui_command_data", ["Cmiss/Cmgui_command_data.c"],
          include_dirs=["/usr/people/blackett/cmgui/source"],
          define_macros=[('PERL_INTERPRETER', '1')],
          library_dirs=["/home/blackett/lib"],
          libraries=["cmgui"]),
        Extension("Cmiss.FE_field", ["Cmiss/FE_field.c"],
          include_dirs=["/usr/people/blackett/cmgui/source"],
          library_dirs=["/home/blackett/lib"],
          libraries=["cmgui_computed_variable"]),
        Extension("Cmiss.FE_element", ["Cmiss/FE_element.c"],
          include_dirs=["/usr/people/blackett/cmgui/source"],
          library_dirs=["/home/blackett/lib"],
          libraries=["cmgui_finite_element"]),
        Extension("Cmiss.FE_node", ["Cmiss/FE_node.c"],
          include_dirs=["/usr/people/blackett/cmgui/source"],
          library_dirs=["/home/blackett/lib"],
          libraries=["cmgui_finite_element"]),
         Extension("Cmiss.Interpreter", ["Cmiss/Interpreter.c"],
          include_dirs=["/usr/people/blackett/perl_interpreter/source"],
          define_macros=[('FULL_NAMES', '1')]),
        Extension("Cmiss.Region.Region", ["Cmiss/Region/Region.c"],
          include_dirs=["/usr/people/blackett/cmgui/source"],
          library_dirs=["/home/blackett/lib"],
          libraries=["cmgui_finite_element"]),
        Extension("Cmiss.Value.C.Value", ["Cmiss/Value/C/Value.c"],
          include_dirs=["/usr/people/blackett/cmgui/source"],
          library_dirs=["/home/blackett/lib"],
          libraries=["cmgui_general", "cmgui_computed_variable"]),
        Extension("Cmiss.Value.C.Matrix", ["Cmiss/Value/C/Matrix.c"],
          include_dirs=["/usr/people/blackett/cmgui/source"],
          library_dirs=["/home/blackett/lib"],
          libraries=["cmgui_computed_variable"]),
         Extension("Cmiss.Value.C.Derivative_matrix", ["Cmiss/Value/C/Derivative_matrix.c"],
          include_dirs=["/usr/people/blackett/cmgui/source"],
          library_dirs=["/home/blackett/lib"],
          libraries=["cmgui_computed_variable"]),
         Extension("Cmiss.Value.C.Element_xi", ["Cmiss/Value/C/Element_xi.c"],
          include_dirs=["/usr/people/blackett/cmgui/source"],
          library_dirs=["/home/blackett/lib"],
          libraries=["cmgui_computed_variable"]),
         Extension("Cmiss.Value.C.FE_value_vector", ["Cmiss/Value/C/FE_value_vector.c"],
          include_dirs=["/usr/people/blackett/cmgui/source"],
          library_dirs=["/home/blackett/lib"],
          libraries=["cmgui_computed_variable"]),
        Extension("Cmiss.Variable.C.Variable", ["Cmiss/Variable/C/Variable.c"],
          include_dirs=["/usr/people/blackett/cmgui/source"],
          library_dirs=["/home/blackett/lib"],
          libraries=["cmgui_computed_variable"]),
        Extension("Cmiss.Variable.C.Derivative", ["Cmiss/Variable/C/Derivative.c"],
          include_dirs=["/usr/people/blackett/cmgui/source"],
          library_dirs=["/home/blackett/lib"],
          libraries=["cmgui_computed_variable"]),
        Extension("Cmiss.Variable.C.Element_xi", ["Cmiss/Variable/C/Element_xi.c"],
          include_dirs=["/usr/people/blackett/cmgui/source"],
          library_dirs=["/home/blackett/lib"],
          libraries=["cmgui_computed_variable_finite_element"]),
        Extension("Cmiss.Variable.C.Finite_element", ["Cmiss/Variable/C/Finite_element.c"],
          include_dirs=["/usr/people/blackett/cmgui/source"],
          library_dirs=["/home/blackett/lib"],
          libraries=["cmgui_computed_variable_finite_element"]),
        Extension("Cmiss.Variable.C.Nodal_value", ["Cmiss/Variable/C/Nodal_value.c"],
          include_dirs=["/usr/people/blackett/cmgui/source"],
          library_dirs=["/home/blackett/lib"],
          libraries=["cmgui"])]
     )

