/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* ***** BEGIN LICENSE BLOCK *****
 * Version: NPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Netscape Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the mozCellML code.
 *
 * The Initial Developer of the Original Code is
 * The Bioengineering Institute, University of Auckland.
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Andrew Miller <ak.miller@auckland.ac.nz>
 *
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the NPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the NPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
#include "nsIModule.h"

#define MOZCELLML_CID                                \
{ /* 484c15ef-f1c0-41f9-b2c8-5409b18542a4 */         \
    0x48fc15ef,                                      \
    0xf1c0,                                          \
    0x41f9,                                          \
    {0xb2, 0xc8, 0x54, 0x09, 0xb1, 0x85, 0x42, 0xa4} \
}

#define MOZCELLML_PROTOCOL_CID                       \
{ /* 27bf966f-54f1-4d67-842c-58df1f863739 */         \
    0x27bf966f,                                      \
    0x54f1,                                          \
    0x4d67,                                          \
    {0x84, 0x2c, 0x58, 0xdf, 0x1f, 0x86, 0x37, 0x39} \
}

#define MOZCELLML_PROTOCOL_VALIDATING_CID            \
{ /* 4973ed64-f107-4f0e-ac03-7266622bb393 */         \
    0x4973ed64,                                      \
    0xf107,                                          \
    0x4f0e,                                          \
    {0xac, 0x03, 0x72, 0x66, 0x62, 0x2b, 0xb3, 0x93} \
}

#define MOZCELLML_RUNONCE_CID_STR                    \
  "f0a5a626-f7f4-45ce-9885-a58a28d3651e"

#define MOZCELLML_RUNONCE_CID                        \
{ /* f0a5a626-f7f4-45ce-9885-a58a28d3651e */         \
    0xf0a5a626,                                      \
    0xf7f4,                                          \
    0x45ce,                                          \
    {0x98, 0x85, 0xa5, 0x8a, 0x28, 0xd3, 0x65, 0x1e} \
}

#define MOZCELLML_GRAPHCLIENT_CID                    \
{ /* 330b8d34-50cd-4620-b9b3-067c0ba27e27*/          \
    0x330b8d34,                                      \
    0x50cd,                                          \
    0x4620,                                          \
    {0xb9, 0xb3, 0x06, 0x7c, 0x0b, 0xa2, 0x7e, 0x27} \
}

#define MOZCELLML_CSVPARSER_CID                      \
{ /* 31319a48-cba6-4f44-8cf4-843bd46cda0f*/          \
    0x31319a48,                                      \
    0xcba6,                                          \
    0x4f44,                                          \
    {0x8c, 0xf4, 0x84, 0x3b, 0xd4, 0x6c, 0xda, 0x0f} \
}

#define MOZCELLML_TRANSLATIONSET_CID                 \
{ /* 600d756c-3322-48ff-8943-ee3d58e6e394*/          \
    0x600d756c,                                      \
    0x3322,                                          \
    0x48ff,                                          \
    {0x89, 0x43, 0xee, 0x3d, 0x58, 0xe6, 0xe3, 0x94} \
}
