function ChangeInitialValue()
{
  var tf = document.getElementById("fieldvalue");
  var value = parseFloat(tf.value);
  if (isNaN(value))
    return;
  var tree = document.getElementById('variable-tree');
  var idx = GetRDFIndexFromTree(window, tree);
  if (idx == -1)
    return;
  if ((window.variables[idx].type ==
       Components.interfaces.mozICellMLVariable.BOUND) ||
       (window.variables[idx].type ==
        Components.interfaces.mozICellMLVariable.SIMPLE))
    return;

  window.variables[idx].initialValue = value;

  var ele = window.rdfvarcont.GetElements();
  for (i = 0; i < window.nvariables; i++)
  {
    var el = window.varres[i];
    var idx = window.rdfsource.GetTarget(el, window.rdfindex, true);
    idx = idx.QueryInterface(Components.interfaces.nsIRDFInt).Value;
    try
    {
      var oldValue = window.rdfsource.GetTarget(el, window.rdfvalue, true);
      window.rdfsource.Unassert(el, window.rdfvalue, oldValue);
      var newValue = window.rdfserv.GetLiteral(window.variables[idx].initialValue);
      window.rdfsource.Assert(el, window.rdfvalue, newValue, true);
      var p_on = (window.variables[idx].initialValue == window.varpristine[idx]);
      var a_res = p_on ? window.var_pristine_res : window.var_modified_res;
      var ua_res = window.rdfsource.GetTarget(el, window.rdfvarprop, true);
      window.rdfsource.Unassert(el, window.rdfvarprop, ua_res);
      window.rdfsource.Assert(el, window.rdfvarprop, a_res, true);
    }
    catch (e)
    {
    }
  }

  return value;
}

function SelectVariable(tc)
{
  tc = tc.QueryInterface(Components.interfaces.nsIDOMXULTreeElement);
  var idx = GetRDFIndexFromTree(tc.window, tc);
  var hb1 = tc.parentNode.getElementsByTagName("hbox").item(1);
  var important = hb1.getElementsByTagName("checkbox").item(2);
  var hbr = hb1.getElementsByTagName("hbox").item(0);
  var lbs = hb1.getElementsByTagName("label");
  var lbname = lbs.item(0);
  var lbunits = lbs.item(2);
  var tname = hb1.getElementsByTagNameNS("http://www.w3.org/1999/xhtml",
                                         "input").item(0);

  if (idx == -1)
  {
    tname.setAttribute("disabled", "true");
    tname.value = "";
    lbname.setAttribute("value", "");
    lbunits.setAttribute("value", "");
    important.setAttribute("disabled", "true");
    return;
  }

  var vlev = tc.window.varlevs[idx];

  var value = "";
  try
  {
    value = vlev.cellmlvar.initialValue;
  }
  catch (e)
  {
  }

  if ((vlev.cellmlvar.type ==
       Components.interfaces.mozICellMLVariable.BOUND) ||
      (vlev.cellmlvar.type ==
       Components.interfaces.mozICellMLVariable.SIMPLE))
    tname.setAttribute("disabled", "true");
  else
    tname.removeAttribute("disabled");

  tname.value = value;
  lbname.setAttribute("value", vlev.name);
  lbunits.setAttribute("value", vlev.cellmlvar.units);
  important.setAttribute("disabled", "false");
  if (vlev.important)
    important.setAttribute("checked", "true");
  else
    important.removeAttribute("checked");
}

function AddVariables(box)
{
  var strb = document.getElementById("mozcellml-string-bundle");
  if (window.translationset == null)
  {
    window.translationset =
      Components.classes["@physiome.org/TranslationSet;1"]
                .createInstance(Components.interfaces.mozITranslationSetLocal);
    window.translationset.bundle = strb.stringBundle;
    window.translationset = window.translationset.QueryInterface(Components.interfaces.mozITranslationSet);
  }

  window.model =
    window.arguments[0].QueryInterface(Components.interfaces.mozICellMLLocal);

  var de = document.documentElement;
  var title = window.model.title + " - " + de.getAttribute("title");
  de.setAttribute("title", title);

  window.model.setStringBundle(window.translationset);

  if (window.arguments[1] == null)
    window.model.initialise();

  // This should be a pref...
  window.useTreeLayout = GetVariableTreePref();

  var statusBar = document.getElementById('status-bar-display');
  var validity = window.model.checkValidity();
  if (validity == "")
    statusBar.label = strb.getString("modelLoadNoError");
  else
    statusBar.label = strb.getFormattedString("modelInvalidReason", [validity]);

  if (window.arguments[1] != true)
    window.integrator = window.arguments[1];
  var variables = new Object();
  var numvars = new Object();
  window.model.getAllVariables(Components.interfaces.mozICellML.NO_INTERFACE_IN,
                               variables, numvars);
  window.variables = variables.value;
  numvars = numvars.value;
  window.imports = new Array();
  var i = 0;

  var rdfserv = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                          .getService(Components.interfaces.nsIRDFService);
  window.rdfserv = rdfserv;
  var rdfcu = Components.classes['@mozilla.org/rdf/container-utils;1']
                        .getService(Components.interfaces.nsIRDFContainerUtils);
  window.rdfcu = rdfcu;
  var rdfsource = Components.classes["@mozilla.org/rdf/datasource;1?name=in-memory-datasource"]
                            .createInstance(Components.interfaces.nsIRDFDataSource);

  window.rdfsource = rdfsource;
  var rdfvariables = rdfserv.GetResource("http://www.physiome.org/rdf/mozCellML#variables");
  var rdfvariable = rdfserv.GetResource("http://www.physiome.org/rdf/mozCellML#variable");
  var rdfname = rdfserv.GetResource("http://www.physiome.org/rdf/mozCellML#variableName");
  window.rdfname = rdfname;
  var rdftype = rdfserv.GetResource("http://www.physiome.org/rdf/mozCellML#variableType");
  var rdfvalue = rdfserv.GetResource("http://www.physiome.org/rdf/mozCellML#variableValue");
  window.rdfvalue = rdfvalue;
  var rdfunits = rdfserv.GetResource("http://www.physiome.org/rdf/mozCellML#variableUnits");
  var rdfindex = rdfserv.GetResource("http://www.physiome.org/rdf/mozCellML#variableIndex");
  var rdfvarprop = rdfserv.GetResource("http://www.physiome.org/rdf/mozCellML#variableProperty");

  window.rdfindex = rdfindex;
  window.rdfvalue = rdfvalue;
  window.rdfvarprop = rdfvarprop;
  window.varres = new Array();

  var rdfvar = rdfserv.GetResource("http://www.physiome.org/rdf/mozCellML#all-variables");
  var rdfvarcont = rdfcu.MakeSeq(rdfsource, rdfvar);
  window.rdfvarcont = rdfvarcont;
  window.boundcount = 0;
  window.varpristine = new Array();

  for (i = 0; i < numvars;)
  {
    var v = window.variables[i];
    if (v.type == Components.interfaces.mozICellMLVariable.BOUND)
    {
      window.boundcount++;
      window.bound = v.name;
      window.boundunit = v.units;
      var boundname = document.getElementById("boundname");
      boundname.value = window.bound + " interval: (";
      var unitsep = document.getElementById("unitsep");
      unitsep.value = window.boundunit + " ,";
      var unitstop = document.getElementById("unitstop");
      unitstop.value = window.boundunit + ")";
      var unitgrid = document.getElementById("unitgrid");
      unitgrid.value = window.boundunit;
    }
    var iv = "";
    try
    {
      iv = v.initialValue;
    }
    catch(e)
    {
      if (e.result != Components.results.NS_ERROR_NOT_AVAILABLE)
      {
        var validity = window.model.checkValidity();
        statusBar.label =
          strb.getFormattedString("modelInvalidReason", [validity]);
      }
    }
    var varRDF = rdfserv.GetAnonymousResource();
    window.varres[i] = varRDF;
    window.varpristine[i] = iv;

    rdfsource.Assert(varRDF, rdfname, rdfserv.GetLiteral(v.name), true);
    rdfsource.Assert(varRDF, rdftype, rdfserv.GetLiteral(TypeToString(v.type)),
                     true);
    rdfsource.Assert(varRDF, rdfvalue, rdfserv.GetLiteral(iv), true);
    rdfsource.Assert(varRDF, rdfunits, rdfserv.GetLiteral(v.units), true);
    rdfsource.Assert(varRDF, rdfindex, rdfserv.GetIntLiteral(i), true);
    window.var_pristine_res = rdfserv.GetLiteral("variable_pristine");
    window.var_modified_res = rdfserv.GetLiteral("variable_modified");
    rdfsource.Assert(varRDF, rdfvarprop, window.var_pristine_res, true);

    if (!window.useTreeLayout)
      rdfvarcont.AppendElement(varRDF);
    else
    {
      var imp = AddOrGetImport(window, v.importNumber);
      var comp = imp.addOrGetComponent(v.componentName);
      comp.AppendElement(varRDF);
    }

    i++;
  }
  box.database.AddDataSource(rdfsource);
  box.builder.rebuild();
  window.nvariables = i;

  if (window.integrator != null)
  {
    // XXX we need to synchronise whether an integration is in
    // progress between all the windows that share integrators.
    ChangeIntegratorButtons(document, true, false);
  }
}

function SelectLocalSave(returnto)
{
  var strb = document.getElementById("mozcellml-string-bundle");
  try
  {
    const nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"]
                       .createInstance(nsIFilePicker);
    fp.init(window, strb.getString("chooseSaveFilename"),
            nsIFilePicker.modeSave);
    fp.appendFilter(strb.getString("allCellML"), "*.cml; *.xml");
    fp.appendFilter("CML", "*.cml");
    fp.appendFilter("XML", "*.xml");
    fp.appendFilter(strb.getString("allFiles"), "*");
    if (fp.show() == nsIFilePicker.returnCancel)
      return;
    returnto.value = fp.file.path;
  }
  catch (ex)
  {
  }
}

function UserRequestSave(saveto, model)
{
  var strb = document.getElementById("mozcellml-string-bundle");
  var file = Components.classes["@mozilla.org/file/local;1"]
                    .createInstance(Components.interfaces.nsILocalFile);
  try
  {
    file.initWithPath(saveto);
  }
  catch (e)
  {
    var statusBar = document.getElementById('status-bar-display');
    statusBar.label = strb.getString("cantSaveToPath");
    return;
  }
  var stream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                    .createInstance(Components.interfaces.nsIFileOutputStream);
  var serializer = Components.classes["@mozilla.org/xmlextras/xmlserializer;1"]
                    .createInstance(Components.interfaces.nsIDOMSerializer);
  stream.init(
              file,
              /* PR_WRONLY | PR_CREATE_FILE | PR_TRUNCATE */
              42,
              /*0644*/420,
              0
             );
  var savedom = model.DOM;
  serializer.serializeToStream(savedom, stream, "UTF8");
}

function CompileIntegrator()
{
  var strb = document.getElementById("mozcellml-string-bundle");
  var statusBar = document.getElementById('status-bar-display');

  if (window.boundcount == 0)
  {
    statusBar.label = strb.getString("mustHaveBoundVar");
  }
  else if (window.boundcount > 1)
  {
    statusBar.label = strb.getString("multipleBoundVars");
  }

  // Get a temporary file name, to store the C code in...
  var dirService = Components.classes["@mozilla.org/file/directory_service;1"]
                             .getService(Components
                                         .interfaces
                                         .nsIDirectoryServiceProvider);
  var p = new Object();
  var lf = dirService.getFile("TmpD", p)
                     .QueryInterface(Components.interfaces.nsILocalFile);
  lf.appendRelativePath("integrator.c");
  lf.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE,
                  /*0600*/384);
  var cfile = lf.path;
  var lfx = dirService.getFile("TmpD", p)
                      .QueryInterface(Components.interfaces.nsILocalFile);
  if (navigator.platform.substring(0, 5) == "Win32")
    lfx.appendRelativePath("integrator.exe");
  else
    lfx.appendRelativePath("integrator");

  lfx.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE,
                  /*0700*/448);
  var xfile = lfx.path;

  var cc = GetCompiler();

  // XXX not all compilers take the same arguments...
  cc += " " + cfile + " -o " + xfile;

  statusBar.label = strb.getString("compilingIntegrator");
  try
  {
    window.integrator = window.model.newIntegrator(cfile, cc, xfile);
    statusBar.label = strb.getString("integratorCompiled");
    ChangeIntegratorButtons(document, true, false);
  }
  catch (e)
  {
    var valerr = window.model.checkValidity();
    if (valerr == "")
      statusBar.label = strb.getString("compilationFailed");
    else
    {
      statusBar.label = strb.getFormattedString("integrationFailedReason",
                                                [valerr]);
    }
    ChangeIntegratorButtons(document, false, false);
  }
  // lf.remove(false);
}

function CleanupWindow()
{
  // Lock the user out from doing bad things while closing...
  ChangeIntegratorButtons(document, false, false);
  if (window.integrator != null)
  {
    window.integrator.destroy();
    window.integrator = null;
  }
}

function KillIntegrator()
{
  var strb = document.getElementById("mozcellml-string-bundle");
  var statusBar = document.getElementById('status-bar-display');
  statusBar.label = strb.getString("killingIntegrator");
  window.integrator.destroy();
  window.integrator = null;
  ChangeIntegratorButtons(document, false, false);
  statusBar.label = strb.getString("integratorKilled");
}

function IntegrationScaleWatcher(npoints)
{
  this.curpoint = 0;
  this.npoints = npoints + 1;
  this.launchDoc = document;
  return this;
}

IntegrationScaleWatcher.prototype =
{
  QueryInterface: function(aIID)
  {
    if (
        aIID.equals(Components.interfaces.mozCellMLIScaleWatcher) ||
        aIID.equals(Components.interfaces.nsISupports) ||
        aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
        aIID.equals(Components.interfaces.CmguiIApplicationBootstrap)
       )
    {
      return this;
    }
    throw Components.results.NS_NOINTERFACE;
  },

  cmguiReady: function(cdf)
  {
    this.commandData = cdf.createCommandData();

    window.openDialog(
                      "chrome://mozcellml/content/integrationresult.xul",
                      "_blank",
                      "chrome,dialog=no",
                      this
                     );
  },

  activateIntegration: function()
  {
    this.live = true;
    if (!this.closed)
    {
      SetupZincForNewIntegrator(this);
      ChangeIntegratorButtons(this.launchDoc, true, true);
      this.integrator.start
      (
        window.model, this.startx, this.stopx, this.gridx,
        this.abserr, this.relerr, this.maxstep
      );
      var statusBar = this.launchDoc.getElementById('status-bar-display');
      var strb = this.launchDoc.getElementById("mozcellml-string-bundle");
      statusBar.label = strb.getString("integrationStarted");
    }
  },

  scaleChanged: function(variable, newMaxAbs)
  {
    ComputeCmguiScale(this, variable, newMaxAbs);
  },

  progress: function(percent)
  {
    if (this.meter != null)
      this.meter.setAttribute("value", percent);
  },

  done: function()
  {
    var strb = document.getElementById("mozcellml-string-bundle");
    var statusBar = document.getElementById('status-bar-display');
    statusBar.label = strb.getString("integrationDone");
    if (window.integrator != null)
      ChangeIntegratorButtons(document, true, false);
    this.live = false;
    if (this.meter != null)
      this.meter.setAttribute("value", "100%");
  },

  halted: function()
  {
    var strb = document.getElementById("mozcellml-string-bundle");
    var statusBar = document.getElementById('status-bar-display');
    statusBar.label = strb.getString("integrationHalted");
    this.live = false;
    if (window.integrator != null)
      ChangeIntegratorButtons(document, true, false);
  },

  failed: function(emsg)
  {
    var strb = document.getElementById("mozcellml-string-bundle");
    var statusBar = document.getElementById('status-bar-display');
    var idx = emsg.indexOf('/');
    if (idx == -1)
    {
      var err = strb.getFormattedString("integrationFailedReason", [strb.getString(emsg)]);
      statusBar.label = err;
      alert(err);
      this.live = false;
      if (window.integrator != null)
        ChangeIntegratorButtons(document, true, false);
    }
    else
    {
      var emsg1 = emsg.substring(0, idx);
      var emsg2 = emsg.substring(idx + 1);
      var err = strb.getFormattedString("integrationFailedReason", [strb.getFormattedString(emsg1, [emsg2])]);
      statusBar.label = err;
      alert(err);
      this.live = false;
      if (window.integrator != null)
        ChangeIntegratorButtons(document, true, false);
    }
  },

  live: false,
  closed: false
};

function StartIntegration()
{
  var strb = document.getElementById("mozcellml-string-bundle");
  var statusBar = document.getElementById('status-bar-display');

  /* Validate the results... */
  var startx = parseFloat(document.getElementById('startx').value);
  var stopx = parseFloat(document.getElementById('stopx').value);
  var gridx = parseFloat(document.getElementById('gridx').value);
  var relerr = parseFloat(document.getElementById('relerr').value);
  var abserr = parseFloat(document.getElementById('relerr').value);
  var maxstep = parseFloat(document.getElementById('maxstep').value);
  if (isNaN(startx) || !isFinite(startx))
  {
    statusBar.label = strb.getString("invalidStartingBound");
    return;
  }
  if (isNaN(stopx) || !isFinite(stopx))
  {
    statusBar.label = strb.getString("invalidEndingBound");
    return;
  }
  if (isNaN(gridx) || !isFinite(gridx))
  {
    statusBar.label = strb.getString("invalidBoundResolution");
    return;
  }
  if (isNaN(relerr) || !isFinite(relerr))
  {
    statusBar.label = strb.getString("invalidRelErr");
    return;
  }
  if (isNaN(abserr) || !isFinite(abserr))
  {
    statusBar.label = strb.getString("invalidAbsErr");
    return;
  }
  if (isNaN(maxstep) || !isFinite(maxstep))
  {
    statusBar.label = strb.getString("invalidMaxStep");
    return;
  }

  var diff = stopx - startx;
  if (diff < 0)
    diff = -diff;
  var irw = new IntegrationScaleWatcher(parseInt(diff / gridx));
  irw.startx = startx;
  irw.stopx = stopx;
  irw.gridx = gridx;
  irw.abserr = abserr;
  irw.relerr = relerr;
  irw.maxstep = maxstep;
  irw.model = window.model;
  irw.variables = new Array();
  irw.maxima = new Array();
  irw.colour = new Array();

  var i = 0, j = 0;
  for (i = 0; i < window.nvariables; i++)
  {
    if (window.variables[i].type !=
        Components.interfaces.mozICellMLVariable.BOUND &&
        window.variables[i].type !=
        Components.interfaces.mozICellMLVariable.CONSTANT)
    {
      irw.maxima[j] = 0;
      irw.colour[j] = parseInt(Math.random() * 0xffffff);
      irw.variables[j++] = window.variables[i];
    }
  }
  irw.nvariables = j;
  if (window.integrator == null)
    alert("Internal error: window.integrator is null!");
  irw.integrator = window.integrator;
  irw.maindoc = document;
  irw.mainwin = window;
  irw.bound = window.bound;
  irw.boundunit = window.boundunit;

  // We connect before the integrator is started. This allows us to avoid
  // caching any results. Continue the process once the cmgui connection
  // is up.
  window.model.startCmgui(ProxyToMain(irw,
                                      Components.interfaces
                                                .CmguiIApplicationBootstrap));
}

function CancelIntegration()
{
  if (window.integrator != null)
  {
    ChangeIntegratorButtons(document, true, false);
    window.integrator.suspend();
  }
}

function fitmodel()
{
  window.openDialog(
                    "chrome://mozcellml/content/fitmodel.xul",
                    "_blank",
                    "chrome,dialog=no",
                    window.model,
                    window.bound,
                    window.boundunit,
                    window.variables,
                    window.nvariables
                   );
}

function ModifyInitialCondition(tb)
{
  var tc = tb.parentNode.parentNode.parentNode.getElementsByTagName('tree').item(0);
  var newval = parseInt(tb.value);

  alert(tc);
  alert(tc.window);
  if (tc.window.activeModel == null)
    return;

  if (!tc.window.activeModel.dirty)
  {
    // Time to clone the active model to make a new model, which becomes the
    // new active model...
    var omod = tc.window.activeModel;
    var nmod = new ModelInstance(tc.cellml);
    nmod.dirty = true;
    nmod.startx = omod.startx;
    nmod.stopx = omod.stopx;
    nmod.gridx = omod.gridx;
    // Temporarily unlock this window...
    var oldlock = tc.window.lockon.getAttribute("checked");
    tc.window.lockon.setAttribute("checked", "false");

    tc.window.updateModel(nmod);

    nmod.addToRDF
    (
     tc.window.rwin.rdfserv, tc.window.rwin.rdfsource_latest,
     tc.window.models_latest, tc.window.rwin.model_name_r,
     tc.window.rwin.inst_id_r
    );
    nmod.addToRDF
    (
     tc.window.rwin.rdfserv, tc.window.rwin.rdfsource_flat,
     tc.window.models_flat, tc.window.rwin.model_name_r,
     tc.window.rwin.inst_id_r
    );
    nmod.addToRDF
    (
     tc.window.rwin.rdfserv, tc.window.rwin.rdfsource_nested,
     tc.window.models_nested, tc.window.rwin.model_name_r,
     tc.window.rwin.inst_id_r
    );

    // Restore the lock state from before...
    tc.window.lockon.setAttribute("checked", oldlock);
  }

  var idx = GetRDFIndexFromTree(tc.window, tc);
  if (idx == -1)
    return;
}
