function TypeToString(v)
{
  var strb = document.getElementById("mozcellml-string-bundle");
  switch (v)
  {
    case Components.interfaces.mozICellMLVariable.CONSTANT:
      return strb.getString("varTypeConstant");
    case Components.interfaces.mozICellMLVariable.SIMPLE:
      return strb.getString("varTypeMathematical");
    case Components.interfaces.mozICellMLVariable.DIFFERENTIAL:
      return strb.getString("varTypeDifferential");
    case Components.interfaces.mozICellMLVariable.BOUND:
      return strb.getString("varTypeBound");
  }
  return "UnknownType" + v;
}

function RandomHexDigits(n)
{
  var i, s = "";
  for (i = 0; i < n; i++)
    s += "0123456789abcdef".charAt(Math.random() * 16);
  return s;
}

function MakeRandomUUID()
{
  return RandomHexDigits(8) + "-" + RandomHexDigits(4) + "-" +
         RandomHexDigits(4) + "-" + RandomHexDigits(4) + "-" +
         RandomHexDigits(12);
}

function nyble2hex(x)
{
  if (x < 10)
    return "" + x;
  switch (x)
  {
    case 10:
      return 'A';
    case 11:
      return 'B';
    case 12:
      return 'C';
    case 13:
      return 'D';
    case 14:
      return 'E';
    case 15:
      return 'F';
  }
}

function hex2nyble(x)
{
  var c = x.charCodeAt(0);
  if (c >= 0x30 && c <= 0x39)
    return c - 0x30;
  if (c >= 0x41 && c <= 0x46)
    return c - 0x37;
  return c - 0x57;
}

function ascolour(val)
{
  return "#" + nyble2hex((val & 0xf0)>>4) +
               nyble2hex(val & 0xf) +
               nyble2hex((val & 0xf000)>>12) +
               nyble2hex((val & 0xf00)>>8) +
               nyble2hex((val & 0xf00000)>>20) +
               nyble2hex((val & 0xf0000)>>16);
}

function colourtonumber(col)
{
  // The hex number is written back-to-front...
  return (hex2nyble(col.substring(5, 6)) << 20) |
         (hex2nyble(col.substring(6, 7)) << 16) |
         (hex2nyble(col.substring(3, 4)) << 12) |
         (hex2nyble(col.substring(4, 5)) << 8) |
         (hex2nyble(col.substring(1, 2)) << 4) |
         hex2nyble(col.substring(2, 3));
}

function TimerOn()
{
  var d = new Date();
  window.secs = d.getSeconds();
  window.msecs = d.getMilliseconds();
}

function TimerOff()
{
  var d = new Date();
  var secs = d.getSeconds();
  var msecs = d.getMilliseconds();
  return (secs - window.secs) * 1000 + (msecs - window.msecs);
}

function GetRDFIndexFromTree(obj, t)
{
  try
  {
    var treeidx = t.view.selection.currentIndex;
    var builder = t.view.QueryInterface(Components.interfaces.nsIXULTreeBuilder);
    var resource = builder.getResourceAtIndex(treeidx);
    var idxnode = obj.rdfsource_active.GetTarget(resource, obj.rdfindex, true);
    return idxnode.QueryInterface(Components.interfaces.nsIRDFInt).Value;
  }
  catch (e)
  {
     return -1;
  }
}

function ProxyToMain(object, iface)
{
    var eqs = Components.classes["@mozilla.org/event-queue-service;1"]
                              .getService(Components.interfaces.nsIEventQueueService);
    var main_thread = eqs.getSpecialEventQueue(Components.interfaces.nsIEventQueueService.UI_THREAD_EVENT_QUEUE);

    var proxyObjectManager = Components.classes["@mozilla.org/xpcomproxy;1"]
                                       .getService(Components.interfaces.nsIProxyObjectManager);

    const PROXY_SYNC = 0x01;
    const PROXY_ALWAYS = 0x04;
    return proxyObjectManager.getProxyForObject(main_thread, iface, object,
                                                PROXY_SYNC | PROXY_ALWAYS);
}
