#!/usr/bin/python
# Copyright (C) 2002,  Christof Meerwald <cmeerw@web.de>
# http://cmeerw.org/xpcard/

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA

import sys, time, thread

from omniORB import CORBA

import CosNaming
import XPCOM
import pcsc


XPCARDCONTEXT_CONTRACTID = '@cmeerw.org/XPCard/Context;1'


orb = CORBA.ORB_init(sys.argv)
poa = orb.resolve_initial_references("RootPOA")

poaManager = poa._get_the_POAManager()
poaManager.activate()


nsctx = orb.resolve_initial_references('NameService')._narrow(CosNaming.NamingContextExt)
cman = nsctx.resolve_str('ComponentManager')._narrow(XPCOM.ComponentManager)

context = cman.create_instance(XPCARDCONTEXT_CONTRACTID)._narrow(pcsc.Context)



context.establish(pcsc.Base.SCOPE_SYSTEM)
card, active_protocol = context.connect('Towitoko Chipdrive Reader 0 0',
                                        pcsc.Base.SHARE_SHARED,
                                        pcsc.Base.PROTOCOL_T0 | pcsc.Base.PROTOCOL_T1)

print 'active protocol:', active_protocol

reader_names, state, active_protocol, atr = card.status()
print 'reader names:', reader_names
print 'state:', state
print 'active protocol:', active_protocol
print 'atr:', repr(atr)


card.disconnect(pcsc.Base.LEAVE_CARD)
context.dispose()
